import java.util.*;

public class DemoCollections
{
    public static void stringListDemo() {
        String[] array = new String[]{"Jan", "Petr", "Jan", null};
        //List<String> list = new ArrayList<>();
        //List<String> list = List.of("Jan", "Petr", "Jan");
        List<String> list = Arrays.asList(new String[]{"Jan", "Petr", "Jan", null});
            
        list.add("Jan");
        list.add("Petr");
        list.add("Jan");
        list.add(null);
        
        array[3] = "Karel";
        //list.add(5, "Karel");
        list.set(3, "Karel");
        
        
        System.out.println(array[4]);
        System.out.println(list.get(4));

        Iterator<String> iter = list.iterator();
        while (iter.hasNext()) {
            String str = iter.next();
            System.out.println(str);
        }
        
        for (String str: list) {
            System.out.println(str);
        }
        
        for (int i = 0; i < list.size(); i++) {
            String str = list.get(i);
        }
    }
    
    public static void stringSetDemo() {
        Set<String> set = new HashSet<>();
            
        set.add("Jan");
        set.add("Petr");
        set.add("Jan");
        set.add(null);
        
        //set.add(5, "Karel");
        //set.set(3, "Karel");
        
        //System.out.println(list.get(4));

        Iterator<String> iter = set.iterator();
        while (iter.hasNext()) {
            String str = iter.next();
            System.out.println(str);
        }
        
        for (String str: set) {
            System.out.println(str);
        }
        
        //for (int i = 0; i < list.size(); i++) {
        //    String str = list.get(i);
        //}
    }
    
    public static void demo2Dlist() {
        String[][] array = new String[10][10];
        List<List<String>> list;
        
        list = new ArrayList<>();
        list.add(new ArrayList());
        list.add(new ArrayList());
        list.add(new ArrayList());
        list.add(new ArrayList());
        list.add(new ArrayList());
        list.add(new ArrayList());
        list.add(new ArrayList());
        list.add(new ArrayList());
        list.add(new ArrayList());
        list.add(new ArrayList());
        
        //array[2][3];
        list.get(2).get(3);
        
        for (List<String> raw : list) {
            for (String val: raw) {
                
            }
        }
    }
    
    public static void demoMap() {
        //Map<String, List<Integer>> map = new HashMap<>();
        //map.put("Jan", new ArrayList<>());
        //map.get("Jan").add(20_000);
        
        Map<String, Integer> map = new HashMap<>();

        map.put("Jan", 20_000);
        map.put("Karel", 30_000);
        map.put("Pepa", 20_000);
        map.put("Jan", 50_000);
        
        
        int salary = map.get("Jan");
        
        map.keySet();
        map.values();
        map.entrySet();
        
        for (String key: map.keySet()) {
            int s = map.get(key);
        }
        
        for (Map.Entry<String, Integer> entry: map.entrySet()) {
            String key = entry.getKey();
            int val = entry.getValue();
        }
    }
}
